; MSBLKARC.LSP - 07.06.04	fuer TRICSY-ST
; Archivieren der Blockverwaltung
; 07.06.96 KST ARJ-Dateien im Verzeichnis progcom
; 05.03.97 KST Alle DOS-Befehle innerhalb einer Batchdatei (MSARCH.BAT)
;               ausfhren
; 07.03.97 KST Test, ob arj.bat vorhanden ist.
; 09.04.97 KST DWG.REC, falls vorhanden, beim Arch. aller Gruppen zuerst lschen.
; 30.08.97 KST fr ACAD14, steht nun in progcom
; 30.11.99 KST BLKARC.DCL in progcom_dir
; 04.06.00 KBO Anpassung Funktion 'anf_cmdstr' an ACAD v15
;              Anpassung an ARJ32.EXE
; 30.01.03 KBO changed call to 'getfiled()' to allow input without extension
; 15.12.03 KST neuer Parameter bei Aufruf, da in BV neue Ebene (Library)
; 20.10.04 KST Archivieren der Bibliotheken, nicht Gruppen
;
;==================================================================

(defun ms:msblkarc (LibVerz GroupVerz GroupName BlockFlag / Ziel Auswahl)

  (newerr "ms:msblkarc > msblkarc")


  ;------------------------------------------------------------------
  ;--- Anf.zeichen in CmdStr setzen ---------------------------------
  (defun anf_cmdstr ( line / ret)
      (setq ret (strcat "\"" line "\""))
  )

  ;--------------------------------------------------------------
  ;--- Block-Pfad setzen ----------------------------------------
  (defun blk_pfad ( / CmdStr Blk_dir)

   		;--- richtigen Pfad setzen fr Blockverwaltung
   		;--- Blockverwaltung ---
        	;(setq Blk_dir (strcase (strcat bvsld_dir "\\" LibVerz)))
       		(setq Blk_dir (strcase (strcat bvsld_dir)))
	        (setq Dir_Datei "TSMB")

   		;--- auf das richtig Laufwerk wechseln
   		(setq CmdStr (substr Blk_dir 1 2))
   		(write-line CmdStr Batch_File)

   		;--- Pafd setzen ---
   		(setq CmdStr (substr Blk_dir 3))
   		(setq CmdStr (anf_cmdstr CmdStr))
   		(setq CmdStr (strcat "cd " CmdStr))
   		(write-line CmdStr Batch_File)

   		(setq ret Blk_Dir)
  ) ; block_pfad

  ;------------------------------------------------------------------
  ;--- Archivierungsfunktion ----------------------------------------
  (defun archiv (Ziel Auswahl / CmdStr StartPath File end DateiName DateiDescr
                                Blk_dir Arj_Prog Arj_File Dwg_Rec)

      (prompt (C_GT "ARCHIVING"))
      ;---------------------------------------------------------------
      ;--- Batchdatei zum Ausfhren der DOS-Befehle ffnen ---
      (setq Batch_File (open (strcat bvprog_dir "\\MSARCH.BAT") "w"))
      (if Batch_File (progn
          (write-line "@ECHO OFF" Batch_File)
          ;--- in das Verzeichnis der Blcke wechseln ---
          (setq Blk_Dir  (blk_pfad))
          (setq Arj_Prog (anf_cmdstr (strcat bvprog_dir "\\arj32")))
          (setq Arj_File (anf_cmdstr Ziel))

          ;--- wenn Archiv schon vorhanden ist LOESCHEN !!!
          (setq CmdStr (strcat "IF EXIST " Arj_File " DEL " Arj_File))
          (write-line CmdStr Batch_File)

          ; --- ARCHIVIEREN ----------------------------------------------
          ; --- alle Blcke ----------------------------------------------
          (if (= Auswahl 1)  (progn
              ; --- DWG.REC, falls vorhanden, lschen ---
              (setq CmdStr (strcat "DEL " (anf_cmdstr (strcat Blk_dir "\\DWG.REC"))))
              (write-line CmdStr Batch_File)

              ; --- TSMB.OLD, falls vorhanden, lschen ---
              (setq CmdStr (strcat "DEL " (anf_cmdstr (strcat  Blk_dir "\\TSMB.OLD"))))
              (write-line CmdStr Batch_File)

              ; --- Archivieren  ---
              (setq CmdStr (strcat Arj_Prog " a -r " Arj_File " *.* "
                                   "-x*.old -x*.bak -x*.loc -y -je -jt -hm -hf1"))
              (write-line CmdStr Batch_File)
              (write-line "if errorlevel 2 goto fehler" Batch_File)
              (write-line "goto Ende" Batch_File)
          )) ; if alle Blcke

          ;--- Blcke einer Lib -------------------------------------------
          (if (= Auswahl 2) (progn
              ;--- Pafd setzen ---
              (setq CmdStr (strcat "cd " (anf_cmdstr LibVerz)))
              (write-line CmdStr Batch_File)

              ;--- Archivieren  ---
              (setq CmdStr (strcat Arj_Prog " a -r " Arj_File " *.* "
                                   "-x*.old -x*.bak -x*.loc -y -je -jt -hm -hf1"))
              (write-line CmdStr Batch_File)
              (write-line "if errorlevel 2 goto fehler" Batch_File)

              ;--- DWG.REC schreiben (Libname) und zu Archiv hinzufgen -----
              (setq DateiName  (strcat Blk_dir "\\DWG.REC"))
              (setq DateiDescr (open DateiName "w"))
              (write-line GroupName DateiDescr)
              (close DateiDescr)

              ; Datei an Archiv anfgen
              (setq Dwg_Rec (anf_cmdstr DateiName))
              (setq CmdStr (strcat Arj_Prog " m -e " Arj_File " " Dwg_Rec))
              (write-line CmdStr Batch_File)
              (write-line "if errorlevel 1 goto fehler" Batch_File)
              (write-line "goto Ende" Batch_File)
          )) ; if Blcke einer Gruppe

          ;--- Batchdatei schlieen ---
          (write-line ":Fehler" Batch_File)
          (write-line "echo.\necho.\necho." Batch_File)
          (write-line (strcat "echo                Bei der Archivierung"
                      " ist ein Fehler aufgetreten!") Batch_File)
          (write-line "echo.\necho.\necho.\npause" Batch_File)
          (write-line ":Ende" Batch_File)
          (close Batch_File)

          ;--- Batchdatei ausfhren ---
          (ms_shell (anf_cmdstr (strcat bvprog_dir "\\MSARCH.BAT")))

      )); Batch-Datei
  ) ; archiv

  ;------------------------------------------------------------------
  ;--- Aktionen des Fensters BLKARC ---------------------------------
  (defun actionbl ( / key a )
      (setq a 1)
      (cond
        ((= $key "ok")
            ; Auswahl der Archivfunktion
            (if (= (get_tile "alleBlk") "1") (progn
                (done_dialog 1)    ; alle Bibliotheken
            )(progn
                (done_dialog 2)    ; eine Bibliothek
            ))
        )

        ((= $key "cancel")
            (done_dialog 0)
        )
      ) ; cond
  ) ; action

  ;----------------------------------------------------------------------------
  ;------ Hauptroutine --------------------------------------------------------


 	(if (not (findfile (setq fn (strcat bvprog_dir "\\BLKARC.DCL")))) (progn
		(alert (strcat (C_GT "ERR_FIND_DCL_1") fn (C_GT "ERR_FIND_DCL_2")))
		(exit)
 	))
 	(if (not $BLKARC_DCL_ID$)
		(setq $BLKARC_DCL_ID$ (load_dialog fn))
 	)
    (if (not (new_dialog "BLKARCHIV" $BLKARC_DCL_ID$ )) (progn
		(alert (strcat (C_GT "ERR_LOAD_DCL_1") fn (C_GT "ERR_LOAD_DCL_2")))
	    (L_ExitFunc)
	    (exit)
    ))


    (set_tile "group" (strcat "\"" GroupName "\""))

    (setq Auswahl (start_dialog))
    (unload_dialog $BLKARC_DCL_ID$)

    ;Verarbeitung der Rckgabewerte aus dem Dialogfenster
      ; --- OK ---
    (if (/= Auswahl 0) (progn;;//
        ;--- Testen, ob arj.exe vorhanden ist ---
        (if (= (Arj_Present) "1") (progn
            ;--- Zielpfad mit Dialog bestimmen lassen ---
            (setq Ziel (getfiled (C_GT "NEW_ARCHIVE") "Blocks.exe" "exe" 5))
            ; Archivdatei ist ausgewhlt
            (if (/= Ziel nil) (progn
		(setq Ziel (C_ConvertWINtoDOS Ziel))
                (archiv Ziel Auswahl)
            )) ; if Ziel
        )(progn
            ; --- arj.exe fehlt ---
            ;(alert "ARJ.EXE ist im Programmverzeichnis nicht vorhanden!")
			(alert (C_GT "NO_ARJ"))
        )) ; if arjok
    )) ; if OK
    (olderr)
; (setq ret ret)
); C:MSBLKARC


